//////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                          // 
//                                AGENCIA ESPACIAL MEXICANA                                 //            
//            Simulador de la computadora de vuelo implementada en el CanSat AEM1           //
//            Version: 1.0                                                                  //               
//            Hardware necesario: Arduinio Pro Mini                                         //                                       
//            Fecha: 01/06/2015                                                             //                   
//            Desarrollado por:  -Salvador Hernandez                                        //                                  
//                               -Walter A. Calles                                          //                    
//                                                                                          //
//            Revisado por: Ing. Cesar Enoc Brindis Contreras                               //
//                                                                                          //  
//////////////////////////////////////////////////////////////////////////////////////////////

#include <Wire.h>
#include <stdlib.h>

#define M_PI 3.14159265359

int count=0;

float pitch=0, roll=0, yaw=0, temper=0, bar=0;
float gpsLat=0,gpsLong=0,gpsAlt=0;
int gpsSats=0,gpsHDOP=0;
String gpsDate=" ",gpsTime=" ";

int direccionPayload=0x50; //direccion fisica (I2C) del Payload con corrimiento a la derecha 
                        //o dividida entre dos
void setup()
{
        Wire.begin();
        Serial.begin(9600);
        delay(500);
}

void loop()
{  
        getPitchRoll();
        yaw=getHeading();
        readTemper();
        readBar();        
        readGPS();
        
        delay(10);
        
        if(count>=25)
        {
          count=0;
          Serial.print("% ");
          Serial.print(pitch);
          Serial.print(" ");
          Serial.print(roll);
          Serial.print(" ");
          Serial.print(yaw);
          Serial.print(" ");
          Serial.print(temper);
          Serial.print(" ");
          Serial.print(bar);
          Serial.print(" ");
          Serial.print(gpsDate);
          Serial.print(" ");
          Serial.print(gpsTime);
          Serial.print(" ");
          Serial.print(gpsLat);
          Serial.print(" ");
          Serial.print(gpsLong);
          Serial.print(" ");
          Serial.print(gpsAlt);
          Serial.print(" ");
          Serial.print(gpsSats);
          Serial.print(" ");
          Serial.print(gpsHDOP);
          Serial.print(" ");
          Payload();
        }
        count++;
}

void Payload()
{
      int contador;
      for(contador=1;contador<=4;contador++)
      {
          Wire.beginTransmission(direccionPayload);  //inicia transmicion al pic
          Wire.write(contador);                  //posicion de la memoria en el esclavo 0 a1 127
          Wire.write(1);                         //dato enviado al esclavo 
          Wire.endTransmission();                //detiene la transmicion
          delay(50);
          
          char a=Wire.requestFrom(direccionPayload,6);//solicita al esclavo N bits (direccion,N)
          while(Wire.available()) 
          {
                char c;
                c = Wire.read();    //un bit del esclavo
                Serial.print(c);
                Serial.print("");
          }
    }
    Wire.endTransmission();
    Serial.println(" 0000"); //Se agrega un ultimo dato en ceros si el Payload manda solo 4 datos
    //Serial.println(""); //Si son 5 datos los que manda el Payload, solo se agrega el salto de linea
}

void readGPS ()
        {
          gpsDate="00/00/2000";
          gpsTime="00:00:00";
          gpsLat=0.00;
          gpsLong=0.00;
          gpsSats=0;
          gpsHDOP=9999;
          gpsAlt=0.00;
        }

void getPitchRoll()
        {
        pitch=45.00;
        roll=-90.00;
        }
        
void readTemper ()
        {
          temper=25.00;
        }
        
void readBar ()
        {
          bar=77492.00;
        }

float getHeading()
{
  float heading=320.00;
  return heading;
}

